/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef CUBE_EXCEPTION_H
#define CUBE_EXCEPTION_H   

/*
 *----------------------------------------------------------------------------
 *
 * class CUBException
 *
 *----------------------------------------------------------------------------
 */

#include <string>
#include <iostream>
#include <exception>

namespace cube {
  class CUBException: public std::exception {
  private:
    std::string error_msg;
    
  public:
    
    CUBException  (std::string msg) : error_msg(msg) {}
    ~CUBException () throw()     {}
    
    std::string   get_msg()  const   { return error_msg; }
    
  };

  class CUBExceptionWarning: public std::exception {    
  private:
    std::string warn_msg;
    
  public:
    
    CUBExceptionWarning  (std::string msg) : warn_msg(msg) {}
    ~CUBExceptionWarning () throw()     {}
    
    std::string   get_msg()  const   { return warn_msg; }
    
  };

  std::ostream& operator<< (std::ostream& out, CUBException& exception);

}

#endif
