%module cube

%{
#include <string>
  using std::string;
#include "Cube.h"
#include "CUBException.h"

using namespace cube;
%}

%include "typemaps.i"
%include "typemaps-py.i"

class Cube {

 public:

    Cube();
    ~Cube();

    Cube(const Cube& cube);

    void   def_attr(std::string key, std::string value);
    void   def_mirror(std::string url);

    const Metric*   def_met(std::string name, std::string uom, std::string url, 
			    std::string descr, const Metric* parent);    
    const Module*   def_module(std::string name);
    const Region*   def_region(std::string name, long begln, long endln, 
			       std::string man_url, std::string descr, const Module* mod);
    const Callsite* def_csite(const Module* mod, int line, const Region* callee);
    const Cnode*    def_cnode(const Callsite* csite, const Cnode* parent);
    const Cnode*    def_cnode(const Region* region, const Cnode* parent);   
    const Machine*  def_mach(std::string name);
    const Node*     def_node(std::string name, const Machine* mach);
    const Process*  def_proc(std::string name, int rank, const Node* node);
    const Thread*   def_thrd(std::string name, int rank, const Process* proc);

    void set_sev(const Metric* met, const Cnode*  cnode,  const Thread* thrd,
		 double value); 
    void add_sev(const Metric* met, const Cnode*  cnode,  const Thread* thrd,
		 double incr); 
    void set_sev(const Metric* met, const Region* region, const Thread* thrd,
		 double value);
    void add_sev(const Metric* met, const Region* region, const Thread* thrd,
		 double incr);
    void write(std::string path);
};
