/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

/************************************************
             AggrModeDlg.cpp

 ************************************************/

#include "AggrModeDlg.h"
#include "PresenterApp.h"
#include "PresenterFrame.h"
#include "Browser.h"

using namespace std;
using namespace cube;

BEGIN_EVENT_TABLE(AggrModeDlg, wxDialog)
  EVT_BUTTON       (ID_AGGR_HELP,   AggrModeDlg::OnHelp)
END_EVENT_TABLE()

AggrModeDlg::AggrModeDlg(wxWindow* parent) : 
  wxDialog(parent, -1, "Aggregation mode selection", 
	   wxPoint(0,0), wxSize(300, 150)) {
  wxString text;  
  wxBoxSizer* sizer = new wxBoxSizer(wxVERTICAL);
  wxString choices[] = {"Max root node", "Sum of the root nodes"};
  radios = 
    new wxRadioBox(this, -1, "Aggregation mode", 
		   wxDefaultPosition, wxSize(300, 150),
		   2, choices); 
  sizer->Add(radios,
	     1, 
	     wxEXPAND|wxALL, 
	     10);

  wxBoxSizer* botsizer = new wxBoxSizer(wxHORIZONTAL);
  botsizer->Add(new wxButton(this, wxID_OK, _("&Ok")), 0, 
		wxALIGN_CENTRE_VERTICAL|wxALL, 10);
  botsizer->Add(new wxButton(this, ID_AGGR_HELP, _("&Help")), 0, 
		wxALIGN_CENTRE_VERTICAL|wxALL, 10);

  sizer->Add(botsizer, 0, wxALIGN_CENTRE, 0);
  SetSizer(sizer);

}

int AggrModeDlg::get_selection() {
  return radios->GetSelection();
}

void AggrModeDlg::OnHelp() {
  PresenterFrame* frame = ((PresenterApp*)wxTheApp)->get_frame();

  if (frame->get_browser_dlg() == NULL)
    frame->set_browser_dlg(new Browser(frame));
  frame->get_browser_dlg()->
    SetPage("<html><h1>Aggregation of the middle tree</h1><body>The metric value is equal to either max of the roots, or sum of the roots.</body></hmtl>");
  frame->get_browser_dlg()->set_big_size(false);
  frame->get_browser_dlg()->Show(true);
  frame->get_browser_dlg()->Raise();
}
