/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

/************************************************
             Browser.cpp

 ************************************************/

#include "Browser.h"
#include "PresenterApp.h"
#include "PresenterFrame.h"

using namespace std;
using namespace cube;


BEGIN_EVENT_TABLE(Browser, wxFrame)
  EVT_BUTTON  (wxID_OK, Browser::OnOK)
END_EVENT_TABLE()

Browser::Browser(wxWindow* parent) : 
wxFrame(NULL, -1, "CUBE Browser", wxDefaultPosition, wxSize(600, 400)) {
  //wxDialog(parent, -1, "cube browser", wxDefaultPosition, wxSize(800, 600),
  //	   wxDEFAULT_DIALOG_STYLE|wxRESIZE_BORDER) 
  html = new wxHtmlWindow(this, -1, wxDefaultPosition, wxSize(600, 400));
  wxBoxSizer* sizer = new wxBoxSizer(wxVERTICAL);
  sizer->Add(html, 1, wxALL|wxEXPAND, 2);
  // "OK" button
  sizer->Add(new wxButton(this, wxID_OK, _("&Ok")), 0, 
	     wxALIGN_CENTRE|wxTOP, 5);
  
  SetSizer(sizer);
  Centre(wxBOTH);

}

void Browser::OnOK() {
  PresenterFrame* frame = ((PresenterApp*)wxTheApp)->get_frame();
  frame->set_browser_dlg(NULL);
  Close(true);
}

Browser::~Browser() {

}

bool Browser::LoadPage(string url) {
  bool ret = html->LoadPage(url.c_str());
  return ret;
}

void Browser::SetPage(const char* s) {
  html->SetPage(s);
}

void Browser::set_big_size(bool big) {
  if (big) {
    SetSize(600,400);
  } else {
    SetSize(300, 200);
  }

}
