/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

/***************************************
					
       CnodeTree class
     
     
***************************************/


#ifndef CUBE_CNODE_TREE_H
#define CUBE_CNODE_TREE_H

#include <string>

#include "wx/wxprec.h"
#include "wx/wx.h"
#include "wx/treectrl.h"
#include "MidTree.h"

namespace cube {
  class Cnode;
  
  class CnodeTree : public MidTree {
  public:
    CnodeTree(wxWindow* parent); 
    
    void refresh       ();
    void OnDes         (wxCommandEvent& event);
    void OnLoc         (wxCommandEvent& event);
    void OnSourceCode  (wxCommandEvent& event);
    void OnURL         (wxCommandEvent& event);
 
    void OnCalleeLoc         (wxCommandEvent& event);
    void OnCalleeSourceCode  (wxCommandEvent& event);
    
    DECLARE_EVENT_TABLE()

  private:     
    void show_descr_dlg(const Cnode* cnode);    
    void traverse      (wxTreeItemId root);  
    
    void OnExpanded    (wxTreeEvent& event);
    void OnCollapsed   (wxTreeEvent& event);
    void OnRightClick  (wxTreeEvent& event);
    void OnSelChanged  (wxTreeEvent& event);

  };
  
}

#endif
