/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

/***************************************
					
       FlatTree class
     
     
***************************************/


#ifndef CUBE_Flat_TREE_H
#define CUBE_Flat_TREE_H

#include <string>

#include "wx/wxprec.h"
#include "wx/wx.h"
#include "wx/treectrl.h"
#include "MidTree.h"

namespace cube {

  class FlatTree : public MidTree {
  public:
    FlatTree (wxWindow* parent); 
    
    void   refresh     ();
    void   OnDes       (wxCommandEvent& event);
    void   OnLoc       (wxCommandEvent& event);
    void   OnSourceCode(wxCommandEvent& event);
    void   OnURL       (wxCommandEvent& event);

    virtual int  mydepth   (wxTreeItemId id);

    
  private:     
    void traverse          (wxTreeItemId root);  
    
    void OnExpanded    (wxTreeEvent& event);
    void OnCollapsed   (wxTreeEvent& event);
    void OnRightClick  (wxTreeEvent& event);
    void OnSelChanged  (wxTreeEvent& event);

    bool is_module (wxTreeItemId id);
    bool is_region (wxTreeItemId id);
    bool is_subreg (wxTreeItemId id);    
  };
  
}

#endif
