/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/


/***************************************
					
       LocationTree class
     
     
***************************************/


#ifndef CUBE_LOCATION_TREE_H
#define CUBE_LOCATION_TREE_H

#include <string>

#include "wx/wxprec.h"
#include "wx/wx.h"
#include "wx/treectrl.h"
#include "Tree.h"

namespace cube {
  enum LocationPopMenu { 
    Loc_POP_ID_Item1,
    Loc_POP_ID_Item2
  };
  
  class LocationTree : public Tree {
  public:
    LocationTree (wxWindow* parent); 
    ~LocationTree() {}
    
    void refresh();
     
  private:
    void OnExpanded    (wxTreeEvent& event);
    void OnCollapsed   (wxTreeEvent& event);
    void OnRightClick  (wxTreeEvent& event);
    void OnSelChanged  (wxTreeEvent& event);
    
    void traverse(wxTreeItemId root);
 
  };

}

#endif
