/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/


/***************************************
					
       MetricTree class
     
     
***************************************/


#ifndef CUBE_METRIC_TREE_H
#define CUBE_METRIC_TREE_H

#include <string>

#include "wx/wxprec.h"
#include "wx/wx.h"
#include "wx/treectrl.h"
#include "Tree.h"

namespace cube {
  
  enum MetricPopMenu { 
    Met_POP_ID_Des,
    Met_POP_ID_URL
  };
  
  class MetricTree : public Tree {
  public:
    MetricTree    (wxWindow* parent); 
    ~MetricTree()   {}
    void refresh  ();
    void OnDescr  (wxCommandEvent& event);
    void OnURL    (wxCommandEvent& event);
 
    DECLARE_EVENT_TABLE()
      
    
  private:
    void OnExpanded    (wxTreeEvent& event);
    void OnCollapsed   (wxTreeEvent& event);
    void OnRightClick  (wxTreeEvent& event);
    void OnSelChanged  (wxTreeEvent& event);
    
    void traverse   (wxTreeItemId root);    
  };
    
}

#endif
