/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

/***************************************
					
     PresenterApp class
     
     
***************************************/


#ifndef CUBE_PRESENTER_APP_H
#define CUBE_PRESENTER_APP_H

#include "wx/wxprec.h"
#include "wx/wx.h"
#include "wx/dcmemory.h"
#include "wx/imaglist.h"
#include <string>
#include <vector>

namespace cube {

  class PresenterFrame;

  class PresenterApp: public wxApp {
  public:
  
    PresenterApp() {}
    ~PresenterApp();

    PresenterFrame* get_frame()  { return main_frame; }
    wxImageList*    get_image_list();
    std::string get_cur_file()  { return cur_file; }  

    void set_proc_num(int n)    { m_process = n; }
    int  get_proc_num()         { return m_process; }
    void set_thrd_num(int m)    { m_thread  = m; }
    int  get_thrd_num()         { return m_thread; }
    
  private:
    
    virtual bool OnInit();
    void create_image_list();
    void parse_command();
    
    PresenterFrame* main_frame;     
    int m_process; // how many processes
    int m_thread;  // max number of threads per process

    std::string cur_file;

    /* the pre-created colored squares in trees*/
    wxImageList* images;
    static const int square_size = 14;
  };  
  

}

#endif
