/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/


/*******************************************
     Module.cpp

********************************************/

#include <algorithm>

#include "Module.h"
#include "CUBException.h"

using namespace std;
using namespace cube;

const Region* Module::get_child(int i)  const{ 
  if (i < 0 || i >= regionv.size()) 
    throw CUBException("module vector out of range");
  return regionv[i]; 
}
 
void Module::sort_regn() {
  sort(regionv.begin(), regionv.end(), GenLess<Region*>());
}
 
void Module::writeXML(ostream& out, int& id) const{
  int level;
  
  level = get_level();

  out << indent() << "<module id=\"" << id++  << "\">" << endl;
  set_level(level+1);
  out << indent() << "<name>" << get_name() << "</name>" << endl;
  set_level(level);
  out << indent() << "</module>" << endl;
}
