/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

/************************************************

             Severity.cpp

************************************************/

#include "Severity.h"
#include "Location.h"
#include "Thread.h"

using namespace std;
using namespace cube;

Severity::~Severity() {
  // if (sm != NULL) delete sm; // lead to seg fault!!
}

void  Severity::set_sev(const Metric* met, const Cnode*  cnode, 
			const Thread* thrd, double value) {
  sev[met][cnode][thrd] = value;
}
 
double Severity::get_sev(const Metric* met, const Cnode*  cnode,  
			 const Thread* thrd){
  if (sm == NULL)
    return sev[met][cnode][thrd];
  else {
    Metric*   m = const_cast<Metric*>(met);
    Cnode*    c = const_cast<Cnode*>(cnode);
    Location* l = const_cast<Thread*>(thrd); 
    return sev[sm->metm[m]][sm->cnodem[c]][static_cast<Thread*>(sm->sysm[l])];
  }

}
void   Severity::align(SpaceMapping* sm2) {
  sm = sm2;
}

