/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/


#ifndef CUBE__SEVERITY_H
#define CUBE__SEVERITY_H  

/*
 *----------------------------------------------------------------------------
 *
 * class Severity (3D data set)
 *
 +
 *----------------------------------------------------------------------------
 */

#include <iostream>
#include <map>

#include "Space.h"


namespace cube {
  class Cnode;
  class Metric;
  class Thread;
  
  class Severity  {
    
  public:
    
    Severity() { sm = NULL; }
    ~Severity();
    
    void   set_sev(const Metric* met, const Cnode*  cnode,  
		   const Thread* thrd, double value); 
    double get_sev(const Metric* met, const Cnode*  cnode,  
		   const Thread* thrd); 
    void   align  (SpaceMapping* sm);

    std::map<const Metric*, std::map<const Cnode*, 
      std::map<const Thread*, double> > >& get_sev()  { return sev; }
    
  private:
    
    SpaceMapping* sm; // mapping from new space to old space
    std::map<const Metric*, std::map<const Cnode*, std::map<const Thread*, 
      double> > > sev;

  };


}

#endif
