/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/


/*******************************************
     Thread.cpp

********************************************/

#include "Thread.h"
#include "Process.h"

using namespace std;
using namespace cube;

namespace cube {
  bool operator== (const Thread& a, const Thread& b) {
    return a.get_rank() == b.get_rank() && 
      a.get_proc()->get_rank() == b.get_proc()->get_rank();
  }
}

void Thread::writeXML(ostream& out, int& loc_id,
		      map<const Location*, int>& loc_mapping) const{
  int level;
  level = get_level();
  loc_mapping[this] = loc_id;
  out << indent() << "<thread locid=\"" << loc_id++ << "\">" << endl; 
  // out << "\" locId=\"" << thrd.get_locid()<< "\">\n";

  set_level(level+1);
  out << indent() << "<name>" << get_name() << "</name>\n";
  out << indent() << "<rank>" << get_rank() << "</rank>\n";
  set_level(level);
  out << indent() << "</thread>\n";
}
