/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

/******************************************

  Performance Algebra Operation: MEAN

*******************************************/

#include <iostream>
#include <string>
#include <fstream>
#include <vector>
#include "Cube.h"

using namespace std;
using namespace cube;


int main(int argc, char* argv[]) {
  vector<Cube*> cubev;
  if (argc < 3) {
    cout << "Usage: cube_mean <op1> <op2> ... <opN>" << endl;
    exit(1);
  }
  
  vector <string> inputs;
  string output;
  string cur;
  bool out_flag = false;
  // analyze the input command 
  for (int i = 1; i < argc; i++) {
    cur = argv[i];
    if (out_flag) {
      output = cur;
      out_flag = false;
      continue;
    }
    if (cur != "-o") {
      inputs.push_back(cur);
    } else {
      out_flag = true;
    }
  }

  for (int i = 0; i < inputs.size(); i++) {
    ifstream in;
    Cube* cube = new Cube();
    in.open(inputs[i].c_str());
    if (!in.good()) {
      cerr << "Error: open " << inputs[i] << endl;
      exit(1);
    }
    in >> *cube;
    in.close();
    cout << "Reading " << inputs[i] << " done." << endl;
    cubev.push_back(cube);
  }
  
  cout << "++++++++++++ Mean operation begins ++++++++++++++++++++++++++" << endl;
  ofstream out;  
  Cube* newcube = cube_mean(cubev);
  if (output.empty()) out.open("mean.cube");
  else out.open(output.c_str());
  out << *newcube;
  out.close();
  cout << "+++++++++++++ Mean operation ends successfully ++++++++++++++++" << endl;
  
  for (int i = 0; i < cubev.size(); i++)
    delete cubev[i];

  delete newcube;
}
