/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

/******************************************

  Performance Algebra Operation: MERGE

*******************************************/

#include <iostream>
#include <string>
#include <fstream>

#include "Cube.h"

using namespace std;
using namespace cube;


int main(int argc, char* argv[]) {
  Cube *cube1, *cube2;
  cube1 = new Cube();
  cube2 = new Cube();
  if (argc != 3 && argc != 5) {
    cout << "Usage: cube_merge <op1> <op2> [-o output]" << endl;
    exit(1);
  }
  vector <string> inputs;
  string output;
  string cur;
  bool out_flag = false;
  // analyze the input command 
  for (int i = 1; i < argc; i++) {
    cur = argv[i];
    if (out_flag) {
      output = cur;
      out_flag = false;
      continue;
    }
    if (cur != "-o") {
      inputs.push_back(cur);
    } else {
      out_flag = true;
    }
  }

  ifstream in1, in2;
  ofstream out;
  in1.open(inputs[0].c_str());
  if (!in1.good()) {
    cerr << "Error: open " << inputs[0] << endl;
    exit(1);
  }
  in1 >> *cube1;
  in1.close();
  cout << "Reading " << inputs[0] << " done." << endl;
  in2.open(inputs[1].c_str());
  if (!in2.good()) {
    cerr << "Error: open " << inputs[1] << endl;
    exit(1);
  }
  in2 >> *cube2;
  in2.close();
  cout << "Reading " << inputs[1] << " done." << endl;

  cout << "++++++++++++ Merging begins ++++++++++++++++++++++++++" << endl;
  Cube* newcube = cube_merge(*cube1, *cube2);
  if (!output.empty()) out.open(output.c_str());
  else out.open("merge.cube");
  
  out << *newcube;
  out.close();
  cout << "+++++++++++++ Merging ends successfully ++++++++++++++++" << endl;
  
  delete cube1;
  delete cube2;
  delete newcube;
}
