%typemap(python, in) long 
{
  if (PyInt_Check($input))
    {
      $1 = PyInt_AsLong($input);
    }
  else if (PyLong_Check($input))
    {
      $1 = PyLong_AsLong($input);
    }
  else
    {
      PyErr_SetString(PyExc_TypeError, "not an integer");
      return NULL;
    }
}

%typemap(python, in) std::string 
{

  if (PyString_Check($input))
    {
      $1 = PyString_AsString($input);
    }
  else
    {
      PyErr_SetString(PyExc_TypeError, "not a string");
      return NULL;
    }
}

%exception 
{	
  try 	
    {	
      $action
    }	
  catch(CUBException e) 
    {
      PyErr_SetString(PyExc_SystemExit, const_cast<char*>(e.get_msg().c_str()));   
      return NULL;
    }
}

