/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 2003-2004                                                **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef EARL_BUFTRACE_H
#define EARL_BUFTRACE_H

/*
 *----------------------------------------------------------------------------
 *
 * class BufTrace
 *
 * This class adds a history buffer to the RndTrace class
 *
 *----------------------------------------------------------------------------
 */

#include <map>

#include "History.h"
#include "Event.h"
#include "RndTrace.h"

namespace earl 
{
  class State;
  
  class BufTrace : public RndTrace
  {
  public:
    
    BufTrace(std::string path);
    
    Event get_event(long pos);
    void  get_state(long pos, State& state);
    
  private:
    
    EventBuffer       buffer;
    History           history;
  };
}
#endif






