/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  Copyright (c) 2003-2004                                                **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef EARL_MPI_COLLECTIVEQUEUE_H
#define EARL_MPI_COLLECTIVEQUEUE_H

/*
 *----------------------------------------------------------------------------
 *
 * class MPI_CollectiveQueue
 *
 *----------------------------------------------------------------------------
 */

#include <list>
#include <vector>

#include "Event.h"

namespace earl
{
  class Communicator;
  class Grid;

  class MPI_CollectiveQueue
  {
  public:
  
    MPI_CollectiveQueue(const Grid* grid);

    void   mpicoll(std::vector<Event>& out); 
    void   queue_mpicoll(Event cexit);
    void   dequeue_mpicoll();

  private:
  
    // (com_id, rank) |-> event (MPICExit_rep) 
    std::vector<std::vector<std::list<Event> > > mpicexitv; 
  
    Communicator* completed;
  };
}
#endif






