/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  Copyright (c) 2003-2004                                                **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef EARL_OMP_COLLECTIVEQUEUE_H
#define EARL_OMP_COLLECTIVEQUEUE_H

/*
 *----------------------------------------------------------------------------
 * class OMP_CollectiveQueue
 *---------------------------------------------------------------------------- 
 */

#include <list>
#include <map>
#include <vector>

#include "Event.h"

namespace earl
{
  class Grid;
  class Process;
  class Thread;

  class OMP_CollectiveQueue
  {
  public:
  
    OMP_CollectiveQueue(const Grid* grid);

    void   ompcoll(std::vector<Event>& out);
    void   queue_ompcoll(Event cexit);
    void   dequeue_ompcoll();

  private:

    // (proc_id, thrd_id)  |-> event queue (OMPCExit)  
    std::vector<std::vector<std::list<Event> > > ompcexitv; 

    Process* completed;
  };
}
#endif



