/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  Copyright (c) 2003-2004                                                **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include "OMP_SyncQueue.h"

#include "Location.h"

using namespace earl;
using namespace std;

void      
OMP_SyncQueue::queue_sync(Event sync)
{
  syncm[make_pair(sync.get_lock_id(), sync.get_loc()->get_proc())] = sync;
} 

Event 
OMP_SyncQueue::last_sync(long lkid, Location* loc)
{
  map<pair<long, Process*>, Event>::const_iterator it = 
    syncm.find(make_pair(lkid, loc->get_proc()));
   
   if (it != syncm.end())
     return it->second;
   else
     return NULL;
}









