/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 2003-2004                                                **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef EARL_STATE_H
#define EARL_STATE_H

/*
 *----------------------------------------------------------------------------
 *
 * State
 *
 *----------------------------------------------------------------------------
 */

#include "Calltree.h"
#include "RegionStack.h"
#include "MPI_MessageQueue.h"
#include "MPI_CollectiveQueue.h"
#include "OMP_CollectiveQueue.h"
#include "OMP_SyncQueue.h"

namespace earl
{
  class State : public Calltree,
		public RegionStack,
		public MPI_CollectiveQueue,
		public MPI_MessageQueue,
		public OMP_CollectiveQueue,
		public OMP_SyncQueue		     
  {
  public:
  
    State(const Grid* grid) : 
      RegionStack(grid),     
      MPI_CollectiveQueue(grid), 
      OMP_CollectiveQueue(grid), 
      OMP_SyncQueue(), 
      pos(0) 
    {}

    long get_pos() const { return pos; }
    void inc_pos()       { pos++; }  

  private:
  
    long pos;
  };
}
#endif














