#------------------------------------------------------------------------------
# General Settings
#------------------------------------------------------------------------------

CC = gcc
CFLAGS = -g -O2

#------------------------------------------------------------------------------
# VTF3 Support
#------------------------------------------------------------------------------

#VTF3DIR     =
#ELG_VTF3    = elg_vtf3
#VTF3LIB     = -L$(VTF3DIR) -lvtf3
#INST_VTF3   = install-vtf3

#------------------------------------------------------------------------------
# Do not change below
#------------------------------------------------------------------------------

.SUFFIXES:  .cpp .c .f

LIB = ../lib

TOOLS = elg_phy_print elg_log_print $(ELG_VTF3)

all: tools

tools: $(LIB)/elg_types.h $(LIB)/libelg.base.a $(TOOLS)

elg_phy_print: elg_phy_print.c
	$(CC) $(CFLAGS) -o $@ -I$(LIB) elg_phy_print.c -L$(LIB) -lelg.base
elg_log_print: elg_log_print.c
	$(CC) $(CFLAGS) -o $@ -I$(LIB) elg_log_print.c -L$(LIB) -lelg.base
elg_vtf3: elg_vtf3.c
	$(CC) $(CFLAGS) -I$(VTF3DIR) elg_vtf3.c -o elg_vtf3 -I$(LIB) \
	$(VTF3LIB) -L$(LIB) -lelg.base

#------------------------------------------------------------------------------
# Cleanup
#------------------------------------------------------------------------------

clean:
	rm -f a.out core *.o
	rm -f elg_log_print elg_phy_print $(ELG_VTF3) 
