/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef _ELG_ERROR_H
#define _ELG_ERROR_H

#ifdef __cplusplus
#   define EXTERN extern "C" 
#else
#   define EXTERN extern 
#endif

/*
 *-----------------------------------------------------------------------------
 *
 *  EPILOG Library (Event Processing, Investigating, and Logging)
 *
 *  - Error messages
 * 
 *-----------------------------------------------------------------------------
 */

#include <stdarg.h>

/* abort and system error message */
EXTERN void elg_error();                          

/* abort and user error message */
EXTERN void elg_error_msg(const char* fmt, ...);

/* user warning message without abort */
EXTERN void elg_warning(const char* fmt, ...);

/* user control message without abort (printed only if ELG_VERBOSE is set) */
EXTERN void elg_cntl_msg(const char* fmt, ...);

#endif






