/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include "elg_mpireg.h"

#include "elg_trc.h"

int elg_mpi_regid[129];

void elg_mpi_register()
{
  elg_ui4 fid;

  fid = elg_def_file("MPI");
  /*fid = ELG_NO_ID;*/
  
  elg_mpi_regid[ELG__MPI_ABORT] = 
    elg_def_region("MPI_Abort", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);
  elg_mpi_regid[ELG__MPI_ADDRESS] =
    elg_def_region("MPI_Address", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);
  elg_mpi_regid[ELG__MPI_ALLGATHER] =
    elg_def_region("MPI_Allgather", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);
  elg_mpi_regid[ELG__MPI_ALLGATHERV] =
    elg_def_region("MPI_Allgatherv", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);              
  elg_mpi_regid[ELG__MPI_ALLREDUCE] =
    elg_def_region("MPI_Allreduce", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                
  elg_mpi_regid[ELG__MPI_ALLTOALL] =
    elg_def_region("MPI_Alltoall", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);               
  elg_mpi_regid[ELG__MPI_ALLTOALLV] =
    elg_def_region("MPI_Alltoallv", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);            
  elg_mpi_regid[ELG__MPI_ATTR_DELETE] =
    elg_def_region("MPI_Attr_delete", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);      
  elg_mpi_regid[ELG__MPI_ATTR_GET] =
    elg_def_region("MPI_Attr_get", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                
  elg_mpi_regid[ELG__MPI_ATTR_PUT] =
    elg_def_region("MPI_Attr_put", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);         
  elg_mpi_regid[ELG__MPI_BARRIER] =
    elg_def_region("MPI_Barrier", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);              
  elg_mpi_regid[ELG__MPI_BCAST] =
    elg_def_region("MPI_Bcast", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                 
  elg_mpi_regid[ELG__MPI_BSEND] =
    elg_def_region("MPI_Bsend", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                  
  elg_mpi_regid[ELG__MPI_BSEND_INIT] =
    elg_def_region("MPI_Bsend_init", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);            
  elg_mpi_regid[ELG__MPI_BUFFER_ATTACH] =
    elg_def_region("MPI_Buffer_attach", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);    
  elg_mpi_regid[ELG__MPI_BUFFER_DETACH] =
    elg_def_region("MPI_Buffer_detach", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);      
  elg_mpi_regid[ELG__MPI_CANCEL] =
    elg_def_region("MPI_Cancel", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                 
  elg_mpi_regid[ELG__MPI_CART_COORDS] =
    elg_def_region("MPI_Cart_coords", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);            
  elg_mpi_regid[ELG__MPI_CART_CREATE] =
    elg_def_region("MPI_Cart_create", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);       
  elg_mpi_regid[ELG__MPI_CART_GET] =
    elg_def_region("MPI_Cart_get", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);           
  elg_mpi_regid[ELG__MPI_CART_MAP] =
    elg_def_region("MPI_Cart_map", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                  
  elg_mpi_regid[ELG__MPI_CART_RANK] =
    elg_def_region("MPI_Cart_rank", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                
  elg_mpi_regid[ELG__MPI_CART_SHIFT] =
    elg_def_region("MPI_Cart_shift", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);         
  elg_mpi_regid[ELG__MPI_CART_SUB] =
    elg_def_region("MPI_Cart_sub", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                 
  elg_mpi_regid[ELG__MPI_CARTDIM_GET] =
    elg_def_region("MPI_Cartdim_get", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);       
  elg_mpi_regid[ELG__MPI_COMM_COMPARE] =
    elg_def_region("MPI_Comm_compare", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);      
  elg_mpi_regid[ELG__MPI_COMM_CREATE] =
    elg_def_region("MPI_Comm_create", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);          
  elg_mpi_regid[ELG__MPI_COMM_DUP] =
    elg_def_region("MPI_Comm_dup", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                
  elg_mpi_regid[ELG__MPI_COMM_FREE] =
    elg_def_region("MPI_Comm_free", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);           
  elg_mpi_regid[ELG__MPI_COMM_GROUP] =
    elg_def_region("MPI_Comm_group", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);              
  elg_mpi_regid[ELG__MPI_COMM_RANK] =
    elg_def_region("MPI_Comm_rank", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                
  elg_mpi_regid[ELG__MPI_COMM_REMOTE_GROUP] =
    elg_def_region("MPI_Comm_remote_group", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);
  elg_mpi_regid[ELG__MPI_COMM_REMOTE_SIZE] =
    elg_def_region("MPI_Comm_remote_size", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);  
  elg_mpi_regid[ELG__MPI_COMM_SIZE] =
    elg_def_region("MPI_Comm_size", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);              
  elg_mpi_regid[ELG__MPI_COMM_SPLIT] =
    elg_def_region("MPI_Comm_split", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);             
  elg_mpi_regid[ELG__MPI_COMM_TEST_INTER] =
    elg_def_region("MPI_Comm_test_inter", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);    
  elg_mpi_regid[ELG__MPI_DIMS_CREATE] =
    elg_def_region("MPI_Dims_create", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);            
  elg_mpi_regid[ELG__MPI_ERRHANDLER_CREATE] =
    elg_def_region("MPI_Errhandler_create", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);
  elg_mpi_regid[ELG__MPI_ERRHANDLER_FREE] =
    elg_def_region("MPI_Errhandler_free", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);    
  elg_mpi_regid[ELG__MPI_ERRHANDLER_GET] =
    elg_def_region("MPI_Errhandler_get", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);      
  elg_mpi_regid[ELG__MPI_ERRHANDLER_SET] =
    elg_def_region("MPI_Errhandler_set", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);      
  elg_mpi_regid[ELG__MPI_ERROR_CLASS] =
    elg_def_region("MPI_Error_class", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);            
  elg_mpi_regid[ELG__MPI_ERROR_STRING] =
    elg_def_region("MPI_Error_string", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);          
  elg_mpi_regid[ELG__MPI_FINALIZE] =
    elg_def_region("MPI_Finalize", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                  
  elg_mpi_regid[ELG__MPI_GATHER] =
    elg_def_region("MPI_Gather", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                      
  elg_mpi_regid[ELG__MPI_GATHERV] =
    elg_def_region("MPI_Gatherv", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                    
  elg_mpi_regid[ELG__MPI_GET_COUNT] =
    elg_def_region("MPI_Get_count", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                
  elg_mpi_regid[ELG__MPI_GET_ELEMENTS] =
    elg_def_region("MPI_Get_elements", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);          
  elg_mpi_regid[ELG__MPI_GET_PROCESSOR_NAME] =
    elg_def_region("MPI_Get_processor_name", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);
  elg_mpi_regid[ELG__MPI_GET_VERSION] =
    elg_def_region("MPI_Get_version", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);          
  elg_mpi_regid[ELG__MPI_GRAPH_CREATE] =
    elg_def_region("MPI_Graph_create", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);         
  elg_mpi_regid[ELG__MPI_GRAPH_GET] =
    elg_def_region("MPI_Graph_get", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                
  elg_mpi_regid[ELG__MPI_GRAPH_MAP] =
    elg_def_region("MPI_Graph_map", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);               
  elg_mpi_regid[ELG__MPI_GRAPH_NEIGHBORS] =
    elg_def_region("MPI_Graph_neighbors", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);   
  elg_mpi_regid[ELG__MPI_GRAPH_NEIGHBORS_COUNT] =
    elg_def_region("MPI_Graph_neighbors_count", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);
  elg_mpi_regid[ELG__MPI_GRAPHDIMS_GET] =
    elg_def_region("MPI_Graphdims_get", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);       
  elg_mpi_regid[ELG__MPI_GROUP_COMPARE] =
    elg_def_region("MPI_Group_compare", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);       
  elg_mpi_regid[ELG__MPI_GROUP_DIFFERENCE] =
    elg_def_region("MPI_Group_difference", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION); 
  elg_mpi_regid[ELG__MPI_GROUP_EXCL] =
    elg_def_region("MPI_Group_excl", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);             
  elg_mpi_regid[ELG__MPI_GROUP_FREE] =
    elg_def_region("MPI_Group_free", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);           
  elg_mpi_regid[ELG__MPI_GROUP_INCL] =
    elg_def_region("MPI_Group_incl", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);             
  elg_mpi_regid[ELG__MPI_GROUP_INTERSECTION] =
    elg_def_region("MPI_Group_intersection", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION); 
  elg_mpi_regid[ELG__MPI_GROUP_RANGE_EXCL] =
    elg_def_region("MPI_Group_range_excl", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);  
  elg_mpi_regid[ELG__MPI_GROUP_RANGE_INCL] =
    elg_def_region("MPI_Group_range_incl", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);  
  elg_mpi_regid[ELG__MPI_GROUP_RANK] =
    elg_def_region("MPI_Group_rank", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);           
  elg_mpi_regid[ELG__MPI_GROUP_SIZE] =
    elg_def_region("MPI_Group_size", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);              
  elg_mpi_regid[ELG__MPI_GROUP_TRANSLATE_RANKS] =
    elg_def_region("MPI_Group_translate_ranks", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);           
  elg_mpi_regid[ELG__MPI_GROUP_UNION] =
    elg_def_region("MPI_Group_union", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);            
  elg_mpi_regid[ELG__MPI_IBSEND] =
    elg_def_region("MPI_Ibsend", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                      
  elg_mpi_regid[ELG__MPI_INIT] =
    elg_def_region("MPI_Init", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                       
  elg_mpi_regid[ELG__MPI_INITIALIZED] =
    elg_def_region("MPI_Initialized", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);            
  elg_mpi_regid[ELG__MPI_INTERCOMM_CREATE] =
    elg_def_region("MPI_Intercomm_create", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);  
  elg_mpi_regid[ELG__MPI_INTERCOMM_MERGE] =
    elg_def_region("MPI_Intercomm_merge", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);    
  elg_mpi_regid[ELG__MPI_IPROBE] =
    elg_def_region("MPI_Iprobe", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                      
  elg_mpi_regid[ELG__MPI_IRECV] =
    elg_def_region("MPI_Irecv", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                    
  elg_mpi_regid[ELG__MPI_IRSEND] =
    elg_def_region("MPI_Irsend", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                      
  elg_mpi_regid[ELG__MPI_ISEND] =
    elg_def_region("MPI_Isend", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                        
  elg_mpi_regid[ELG__MPI_ISSEND] =
    elg_def_region("MPI_Issend", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                      
  elg_mpi_regid[ELG__MPI_KEYVAL_CREATE] =
    elg_def_region("MPI_Keyval_create", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);        
  elg_mpi_regid[ELG__MPI_KEYVAL_FREE] =
    elg_def_region("MPI_Keyval_free", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);            
  elg_mpi_regid[ELG__MPI_OP_CREATE] =
    elg_def_region("MPI_Op_create", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                
  elg_mpi_regid[ELG__MPI_OP_FREE] =
    elg_def_region("MPI_Op_free", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                 
  elg_mpi_regid[ELG__MPI_PACK] =
    elg_def_region("MPI_Packpack", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                    
  elg_mpi_regid[ELG__MPI_PACK_SIZE] =
    elg_def_region("MPI_Pack_size", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);            
  elg_mpi_regid[ELG__MPI_PCONTROL] =
    elg_def_region("MPI_Pcontrol", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);               
  elg_mpi_regid[ELG__MPI_PROBE] =
    elg_def_region("MPI_Probe", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                        
  elg_mpi_regid[ELG__MPI_RECV] =
    elg_def_region("MPI_Recv", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                     
  elg_mpi_regid[ELG__MPI_RECV_INIT] =
    elg_def_region("MPI_Recv_init", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                
  elg_mpi_regid[ELG__MPI_REDUCE] =
    elg_def_region("MPI_Reduce", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                      
  elg_mpi_regid[ELG__MPI_REDUCE_SCATTER] =
    elg_def_region("MPI_Reduce_scatter", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);     
  elg_mpi_regid[ELG__MPI_REQUEST_FREE] =
    elg_def_region("MPI_Request_free", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);         
  elg_mpi_regid[ELG__MPI_RSEND] =
    elg_def_region("MPI_Rsend", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                        
  elg_mpi_regid[ELG__MPI_RSEND_INIT] =
    elg_def_region("MPI_Rsend_init", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);             
  elg_mpi_regid[ELG__MPI_SCAN] =
    elg_def_region("MPI_Scan", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                         
  elg_mpi_regid[ELG__MPI_SCATTER] =
    elg_def_region("MPI_Scatter", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                    
  elg_mpi_regid[ELG__MPI_SCATTERV] =
    elg_def_region("MPI_Scatterv", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                  
  elg_mpi_regid[ELG__MPI_SEND] =
    elg_def_region("MPI_Send", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                          
  elg_mpi_regid[ELG__MPI_SEND_INIT] =
    elg_def_region("MPI_Send_init", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);               
  elg_mpi_regid[ELG__MPI_SENDRECV] =
    elg_def_region("MPI_Sendrecv", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);               
  elg_mpi_regid[ELG__MPI_SENDRECV_REPLACE] =
    elg_def_region("MPI_Sendrecv_replace", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);  
  elg_mpi_regid[ELG__MPI_SSEND] =
    elg_def_region("MPI_Ssend", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                       
  elg_mpi_regid[ELG__MPI_SSEND_INIT] =
    elg_def_region("MPI_Ssend_init", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);             
  elg_mpi_regid[ELG__MPI_START] =
    elg_def_region("MPI_Start", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                        
  elg_mpi_regid[ELG__MPI_STARTALL] =
    elg_def_region("MPI_Startall", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                 
  elg_mpi_regid[ELG__MPI_TEST] =
    elg_def_region("MPI_Test", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                         
  elg_mpi_regid[ELG__MPI_TEST_CANCELLED] =
    elg_def_region("MPI_Test_cancelled", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);     
  elg_mpi_regid[ELG__MPI_TESTALL] =
    elg_def_region("MPI_Testall", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                   
  elg_mpi_regid[ELG__MPI_TESTANY] =
    elg_def_region("MPI_Testany", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                    
  elg_mpi_regid[ELG__MPI_TESTSOME] =
    elg_def_region("MPI_Testsome", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                 
  elg_mpi_regid[ELG__MPI_TOPO_TEST] =
    elg_def_region("MPI_Topo_test", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                   
  elg_mpi_regid[ELG__MPI_TYPE_COMMIT] =
    elg_def_region("MPI_Type_commit", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);           
  elg_mpi_regid[ELG__MPI_TYPE_CONTIGUOUS] =
    elg_def_region("MPI_Type_contiguous", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);   
  elg_mpi_regid[ELG__MPI_TYPE_EXTENT] =
    elg_def_region("MPI_Type_extent", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);           
  elg_mpi_regid[ELG__MPI_TYPE_FREE] =
    elg_def_region("MPI_Type_free", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);               
  elg_mpi_regid[ELG__MPI_TYPE_HINDEXED] =
    elg_def_region("MPI_Type_hindexed", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);       
  elg_mpi_regid[ELG__MPI_TYPE_HVECTOR] =
    elg_def_region("MPI_Type_hvector", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);         
  elg_mpi_regid[ELG__MPI_TYPE_INDEXED] =
    elg_def_region("MPI_Type_indexed", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);         
  elg_mpi_regid[ELG__MPI_TYPE_LB] =
    elg_def_region("MPI_Type_lb", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                    
  elg_mpi_regid[ELG__MPI_TYPE_SIZE] =
    elg_def_region("MPI_Type_size", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);               
  elg_mpi_regid[ELG__MPI_TYPE_STRUCT] =
    elg_def_region("MPI_Type_struct", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);           
  elg_mpi_regid[ELG__MPI_TYPE_UB] =
    elg_def_region("MPI_Type_ub", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                   
  elg_mpi_regid[ELG__MPI_TYPE_VECTOR] =
    elg_def_region("MPI_Type_vector", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);         
  elg_mpi_regid[ELG__MPI_UNPACK] =
    elg_def_region("MPI_Unpack", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                     
  elg_mpi_regid[ELG__MPI_WAIT] =
    elg_def_region("MPI_Wait", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                          
  elg_mpi_regid[ELG__MPI_WAITALL] =
    elg_def_region("MPI_Waitall", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                   
  elg_mpi_regid[ELG__MPI_WAITANY] =
    elg_def_region("MPI_Waitany", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                   
  elg_mpi_regid[ELG__MPI_WAITSOME] =
    elg_def_region("MPI_Waitsome", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                 
  elg_mpi_regid[ELG__MPI_WTICK] =
    elg_def_region("MPI_Wtick", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                     
  elg_mpi_regid[ELG__MPI_WTIME] =
    elg_def_region("MPI_Wtime", fid, ELG_NO_LNO, ELG_NO_LNO, "MPI", ELG_FUNCTION);                      
}





