/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef _ELG_OMPREG_H
#define _ELG_OMPREG_H

#ifdef __cplusplus
#   define EXTERN extern "C" 
#else
#   define EXTERN extern 
#endif

/* 
 *-----------------------------------------------------------------------------
 *
 *  EPILOG Library (Event Processing, Investigating, and Logging)
 *
 *  - Registration of OMP functions  
 *
 *-----------------------------------------------------------------------------
 */

#define ELG__OMP_DESTROY_LOCK                     0 
#define ELG__OMP_DESTROY_NEST_LOCK                1
#define ELG__OMP_GET_DYNAMIC                      2
#define ELG__OMP_GET_MAX_THREADS                  3
#define ELG__OMP_GET_NESTED                       4
#define ELG__OMP_GET_NUM_PROCS                    5
#define ELG__OMP_GET_NUM_THREADS                  6
#define ELG__OMP_GET_THREAD_NUM                   7
#define ELG__OMP_IN_PARALLEL                      8
#define ELG__OMP_INIT_LOCK                        9 
#define ELG__OMP_INIT_NEST_LOCK                  10
#define ELG__OMP_SET_DYNAMIC                     11
#define ELG__OMP_SET_LOCK                        12
#define ELG__OMP_SET_NEST_LOCK                   13
#define ELG__OMP_SET_NESTED                      14
#define ELG__OMP_SET_NUM_THREADS                 15  
#define ELG__OMP_TEST_LOCK                       16
#define ELG__OMP_TEST_NEST_LOCK                  17 
#define ELG__OMP_UNSET_LOCK                      18
#define ELG__OMP_UNSET_NEST_LOCK                 19

extern int     elg_omp_regid[20];

EXTERN void    elg_omp_register();


#endif









