/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include <stdio.h>
#include <sys/time.h>
#include "elg_pform.h"
#include "lrz.h"

static double elg_time_base = 0.0;

void elg_pform_init() {
  struct timeval tp;
  gettimeofday(&tp, 0);
  elg_time_base = tp.tv_sec;
}

void elg_pform_mpi_init() {}

void elg_pform_mpi_finalize() {} 

/* directory of global file system  */
char* elg_pform_gdir() {
  return ".";
}

/* directory of local file system  */
char* elg_pform_ldir() {
  return gettmpdir();
}

/* is a global clock provided ? */ 
int elg_pform_is_gclock() {
  return 1;
}

/* local or global wall-clock time in seconds */
double elg_pform_wtime() {
  struct timeval tp;
  gettimeofday(&tp, 0);
  return (tp.tv_sec - elg_time_base ) + (tp.tv_usec * 1.0e-6);
}

/* platform name */
char*  elg_pform_name() {
  return "Hitachi SR8000";
}

/* number of nodes */
int elg_pform_num_nodes() {
  return 1;
}

/* unique numeric SMP-node identifier */
long elg_pform_node_id() {
  int coord[3];
  getxyz(coord);
  return (coord[0]*100 + coord[1]*10 + coord[2]);
}

/* unique string SMP-node identifier */
char* elg_pform_node_name() {
  static char node[20];
  int coord[3];
  getxyz(coord);
  sprintf(node, "node%d.%d.%d", coord[0], coord[1], coord[2]);
  return node;
}

/* number of CPUs */
int elg_pform_num_cpus() {
  return 8;
}
