/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "config.h"

int main ()
{
  FILE *out;
  union {
    elg_ui4 i;
    char    c[4];
  } v;
  int i;

  v.i = 0x00010203;

  if ( (out = fopen("config.h", "a")) == NULL ) {
    perror("config.h");
    exit(1);
  }

  for (i=0; i<4; i++) if ( v.c[i] != i ) break;
  if ( i == 4 ) {
    fprintf(out, "\n#define ELG_BYTE_ORDER ELG_BIG_ENDIAN\n");
  } else {
    for (i=0; i<4; i++) if ( v.c[i] != 3-i ) break;
    if ( i == 4 ) {
      fprintf(out, "\n#define ELG_BYTE_ORDER ELG_LITTLE_ENDIAN\n");
    } else {
      fprintf(stderr, "ERROR: unusual byte order\n");
      exit(1);
    }
  }

  fclose(out);
  return 0;
}
