from Tree   import *
from string import * 
from earl   import *

class CallTree(Tree):

    def __init__(self, trace):

        Tree.__init__(self)
        for cnode_id in trace.calltree():
            enter = trace.event(cnode_id)
            data = {}
            data['cnode_id']  = cnode_id
            data['callee']    = trace.get_reg(enter['reg_id'])
            data['callee_id'] = enter['reg_id']
            data['csite_id']  = enter['csite_id']
            if enter['csite_id'] != -1:
                data['line'] = trace.get_csite(enter['csite_id'])['line']
            parent_id = enter['cedgeptr']
            if parent_id != -1:
                self.addnode(cnode_id, data, parent_id)
            else:
                self.addnode(cnode_id, data)
                
    def callee(self, cnode_id):
        return self.data(cnode_id)['callee']

    def callee_id(self, cnode_id):
        return self.data(cnode_id)['callee']

    def csite_id(self, cnode_id):
        return self.data(cnode_id)['csite_id']

    def line(self, cnode_id):
        return self.data(cnode_id)['line']

